# coding: utf-8

"""
    Conekta API

    Conekta sdk  # noqa: E501

    The version of the OpenAPI document: 2.1.0
    Contact: engineering@conekta.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt, StrictStr

class DeleteApiKeysResponse(BaseModel):
    """
    DeleteApiKeysResponse
    """
    active: Optional[StrictBool] = Field(None, description="Indicates if the api key is active")
    created_at: Optional[StrictInt] = Field(None, description="Unix timestamp in seconds of when the api key was created")
    description: Optional[StrictStr] = Field(None, description="A name or brief explanation of what this api key is used for")
    livemode: Optional[StrictBool] = Field(None, description="Indicates if the api key is in production")
    prefix: Optional[StrictStr] = Field(None, description="The first few characters of the authentication_token")
    id: Optional[StrictStr] = Field(None, description="Unique identifier of the api key")
    object: Optional[StrictStr] = Field(None, description="Object name, value is 'api_key'")
    deleted: Optional[StrictBool] = None
    role: Optional[StrictStr] = Field(None, description="Indicates if the api key is private or public")
    __properties = ["active", "created_at", "description", "livemode", "prefix", "id", "object", "deleted", "role"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DeleteApiKeysResponse:
        """Create an instance of DeleteApiKeysResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DeleteApiKeysResponse:
        """Create an instance of DeleteApiKeysResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DeleteApiKeysResponse.parse_obj(obj)

        _obj = DeleteApiKeysResponse.parse_obj({
            "active": obj.get("active"),
            "created_at": obj.get("created_at"),
            "description": obj.get("description"),
            "livemode": obj.get("livemode"),
            "prefix": obj.get("prefix"),
            "id": obj.get("id"),
            "object": obj.get("object"),
            "deleted": obj.get("deleted"),
            "role": obj.get("role")
        })
        return _obj

